Type TGameObject
	Field pos:Point;
	Field _link:TLink, _link_buildings:TLink, _link_draw:TLink;
	Field active:Int;
	Field imgId:Int, frame:Int;
	Field noUpdate:Int
	Field sortCoords:Point;
	Method init:TGameObject(pos:Point, imgId:Int, frame:Int)
		Self.pos=pos;
		Self.imgId=imgId;
		Self.frame=frame;
		sortCoords=New Point;
		TTileMap.getCoords(sortCoords, pos.x, pos.y);
		noUpdate=False;
		active=True;
		Return Self;
	End Method
	Method update(dt:Double)
	End Method
	Method saveToFile(out:TStream)
		WriteDouble(out, pos.x);
		WriteDouble(out, pos.y);
		WriteInt(out, imgId);
		WriteInt(out, frame);
	End Method
	Method loadFromFile(in:TStream)
		Local pos:Point=New Point;
		pos.x=ReadDouble(in);
		pos.y=ReadDouble(in);
		Local imgId:Int=ReadInt(in);
		Local frame:Int=ReadInt(in);
		Self.init(pos, imgId, frame);
	End Method
	
	Method setDraw(scroll:Point)
		resetDraw();
		
		'highlight on marked structure
		If(TTile(Self) And GameManager.player.markedHouse And TTile(Self).faction=GameManager.player.markedHouse.faction)
			If(TTile(Self)=GameManager.player.markedHouse.tile)
				Self.draw(scroll)
				SetBlend(LIGHTBLEND)
				SetColor(128, 128, 128);
			ElseIf(TFruitPicker(GameManager.player.markedHouse) Or TFarm(GameManager.player.markedHouse))
				If(TTileMap.inRangeSup(TTile(Self).coords, GameManager.player.markedHouse.coords, GameManager.player.markedHouse.areaRange))
					Self.draw(scroll)
					SetBlend(LIGHTBLEND)
					SetColor(128, 128, 128);
				EndIf
			EndIf
		EndIf
		
		If(GameManager.player.state=TPlayer.BUILD)
			' make everything dark outside of player domain
			If(TTile(Self) And Not(TTile(Self).faction=GameManager.player.faction))
				SetColor(128, 128, 128);
			EndIf
			If(TStructure(Self) And TStructure(Self).tile And Not(TStructure(Self).tile.faction=GameManager.player.faction))
				SetColor(128, 128, 128);
			EndIf
			If(TTree(Self) And TTree(Self).tile And Not(TTree(Self).tile.faction=GameManager.player.faction))
				SetColor(128, 128, 128);
			EndIf
			'highlight on focusTile
			'If(TTile(Self) And TTile(Self)=GameManager.player.focusTile)
			If(TTile(Self) And GameManager.player.focusTile And Not GameManager.player.endTile)
				If(TTile(Self)=GameManager.player.focusTile)
					Self.draw(scroll)
					SetBlend(LIGHTBLEND)
					SetColor(128, 128, 128);
				ElseIf(GameManager.player.buildId>=0 And GameManager.player.buildId<Len(TControl.buildTemplates) And (TFruitPicker(TControl.buildTemplates[GameManager.player.buildId]) Or TFarm(TControl.buildTemplates[GameManager.player.buildId])))
					If(TTileMap.inRangeSup(TTile(Self).coords, GameManager.player.focusTile.coords, THouse(TControl.buildTemplates[GameManager.player.buildId]).areaRange))
						Self.draw(scroll)
						SetBlend(LIGHTBLEND)
						SetColor(128, 128, 128);
					EndIf
				EndIf
			EndIf
			'highlight on street
			If(TTile(Self) And GameManager.player.buildId=0 And GameManager.player.startTile And GameManager.player.endTile)
				Local direction:Point=New Point;
				If(Abs(GameManager.player.endTile.coords.x-GameManager.player.startTile.coords.x)>Abs(GameManager.player.endTile.coords.y-GameManager.player.startTile.coords.y))
					direction.x=Sgn(GameManager.player.endTile.coords.x-GameManager.player.startTile.coords.x);
				Else
					direction.y=Sgn(GameManager.player.endTile.coords.y-GameManager.player.startTile.coords.y);
				EndIf
				Local currentTile:TTile;
				For Local k:Int=0 To Max(Abs(GameManager.player.endTile.coords.x-GameManager.player.startTile.coords.x), Abs(GameManager.player.endTile.coords.y-GameManager.player.startTile.coords.y))
					currentTile=GameManager.tilemap.data[GameManager.player.startTile.coords.x+direction.x*k, GameManager.player.startTile.coords.y+direction.y*k];
					If(TTile(Self)=currentTile)
						Self.draw(scroll);
						SetBlend(LIGHTBLEND);
						SetColor(128, 128, 128);
						Exit
					EndIf
				Next
			EndIf
			'highlight fruit/crop fields
			If(TTile(Self) And GameManager.player.buildId>=8 And GameManager.player.startTile And GameManager.player.endTile)
				For Local y:Int=Min(GameManager.player.startTile.coords.y, GameManager.player.endTile.coords.y) To Max(GameManager.player.startTile.coords.y, GameManager.player.endTile.coords.y)
					For Local x:Int=Min(GameManager.player.startTile.coords.x, GameManager.player.endTile.coords.x) To Max(GameManager.player.startTile.coords.x, GameManager.player.endTile.coords.x)
						If(GameManager.tilemap.data[x, y]=TTile(Self))
							Self.draw(scroll);
							SetBlend(LIGHTBLEND);
							SetColor(128, 128, 128);
							Exit
						EndIf
					Next
				Next
			EndIf

			
			'preview
			If(GameManager.player.focusTile And ((TStructure(Self) And TStructure(Self).tile=GameManager.player.focusTile) Or (TTree(Self) And TTree(Self).tile=GameManager.player.focusTile)))
			
				If(GameManager.player.buildId>=0 And GameManager.player.buildId<Len(TControl.buildTemplates))
					If(Self=TControl.buildTemplates[GameManager.player.buildId])
						If(Not TStructure(Self).placementPossible(GameManager.player.faction, GameManager.player.focusTile.coords.x, GameManager.player.focusTile.coords.y))
							SetAlpha(0)
							SetBlend(ALPHABLEND)
						Else
							If(TStructure.blink)
								SetAlpha(0)
								SetBlend(ALPHABLEND)
							Else
								SetColor(255, 255, 255)
								SetBlend(ALPHABLEND)
								SetAlpha(0.5)
							EndIf
						EndIf
					Else
						If(TTree(Self) And TTree(Self).structure=TControl.buildTemplates[GameManager.player.buildId])
							If(TStructure.blink Or Not TTree(Self).structure.placementPossible(GameManager.player.faction, GameManager.player.focusTile.coords.x, GameManager.player.focusTile.coords.y))
								SetAlpha(0)
								SetBlend(ALPHABLEND)
							Else
								SetColor(255, 255, 255)
								SetAlpha(0.5)
								SetBlend(ALPHABLEND)
							EndIf
						ElseIf(Not GameManager.player.buildTemplates[GameManager.player.buildId].placementPossible(GameManager.player.faction, GameManager.player.focusTile.coords.x, GameManager.player.focusTile.coords.y))
							SetColor(255, 0, 0);
							'SetBlend(ALPHABLEND)
							'SetAlpha(0.5)
						Else
							If(TTree(Self))
								SetAlpha(0)
								SetBlend(ALPHABLEND)
							EndIf
						EndIf
					EndIf
				Else
					'highlight when deleting
					If(GameManager.player.buildId=-1)
						Self.draw(scroll);
						SetBlend(LIGHTBLEND)
						SetColor(128, 128, 128);
					EndIf
				EndIf
			EndIf
			'make preview invisible if mouse outside of tilemap
			If(Not GameManager.player.focusTile)
				If(GameManager.player.buildId>=0 And GameManager.player.buildId<Len(GameManager.player.buildTemplates))
					If(Self=GameManager.player.buildTemplates[GameManager.player.buildId])
						SetAlpha(0)
						SetBlend(ALPHABLEND)
					EndIf
					If(TTree(Self) And TTree(Self).structure=GameManager.player.buildTemplates[GameManager.player.buildId])
						SetAlpha(0)
						SetBlend(ALPHABLEND)					
					EndIf
				EndIf
			EndIf
		Else

		EndIf
		
	End Method
	Method resetDraw()
		SetBlend(MASKBLEND);
		SetColor(255, 255, 255);
		SetAlpha(1)
	End Method
	Method draw(scroll:Point)
		If(onScreen(scroll))
			DrawImage(TResManager.img[imgId], Floor(pos.x+scroll.x), Floor(pos.y+scroll.y), frame);

		EndIf
	End Method
	Method onScreen:Int(scroll:Point)
		If(pos.x+scroll.x>=-32 And pos.y+scroll.y>=-32 And pos.x+scroll.x <=800+32 And pos.y+scroll.y<=600+32)
			Return True;
		EndIf
		Return False;
	End Method
	Function objCompare:Int(obj1:Object, obj2:Object)
		If(TGameObject(obj1) And TGameObject(obj2))
			'If(Not TGameObject(obj1).onScreen(GameManager.scroll))
			'	If(Not TGameObject(obj2).onScreen(GameManager.scroll))
			'		Return 0;
			'	Else
			'		Return -1;
			'	EndIf
			'ElseIf(Not TGameObject(obj2).onScreen(GameManager.scroll))
			'	If(Not TGameObject(obj1).onScreen(GameManager.scroll))
			'		Return 0;
			'	Else
			'		Return 1;
			'	EndIf
			'EndIf
			If(TGameObject(obj1).sortCoords.y < TGameObject(obj2).sortCoords.y)
				Return -1;
			Else
				If(TGameObject(obj1).sortCoords.y > TGameObject(obj2).sortCoords.y)
					Return 1;
				Else
					If(TGameObject(obj1).sortCoords.x < TGameObject(obj2).sortCoords.x)
						Return -1;
					Else
						If(TGameObject(obj1).sortCoords.x > TGameObject(obj2).sortCoords.x)
							Return 1
						Else
							If(TGameObject(obj1).pos.y <  TGameObject(obj2).pos.y)
								Return -1;
							Else
								If(TGameObject(obj1).pos.y > TGameObject(obj2).pos.y)
									Return 1;
								Else
									Return 0
								EndIf
							EndIf
						EndIf
					EndIf

				EndIf
			EndIf
		Else
			Return 0;
		EndIf
	End Function
End Type

Type TTree Extends TGameObject
	Field scale:Double
	Field tile:TTile
	Field structure:TStructure;
	Method init_TTree:TTree(tile:TTile, structure:TStructure, pos:Point, imgId:Int, frame:Int, scale:Double)
		init(pos, imgId, frame)
		Self.tile=tile;
		If(tile)
			sortCoords.init(tile.coords.x, tile.coords.y)
		EndIf
		Self.structure=structure;
		Self.scale=scale;
		Return Self
	End Method
	Method draw(scroll:Point)
		If(onScreen(scroll))
			SetScale(scale, scale);
			Super.draw(scroll);
			SetScale(1, 1);
		EndIf
	End Method
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
		WriteDouble(out, scale);
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
		scale=ReadDouble(in);
	End Method
End Type


Type TStructure Extends TGameObject
	Const STRUCT_NONE:Int=0;
	Const STRUCT_STREET:Int=1;
	Const STRUCT_HOUSE:Int=2;
	Const STRUCT_FOREST:Int=3;
	Const STRUCT_FRUIT:Int=4;
	Const STRUCT_CROP:Int=5;
	Global blink_timer:Double=0.5, blink:Int=False;

	Field tile:TTile;
	Field coords:Point;
	Field faction:Int;
	Field dx:Int
	Field dy:Int
	Field price:Int;
	Field name:String;
	Method init_TStructure:TStructure(tile:TTile, price:Int, dx:Int, dy:Int, name:String="")
		Self.tile=tile;
		Self.price=price;
		Self.name=name;
		If(tile)
			coords=tile.coords;
			faction=tile.faction;
		Else
			coords=New Point.init()
		EndIf
		Self.dx=dx;
		Self.dy=dy;
		Return Self;
	End Method
	Method getType:Int()
		Return 0;
	End Method
	Method erase()
		active=False;
	End Method
	Method placementPossible:Int(faction:Int, x:Int, y:Int)
		For Local x0:Int=x To x+dx-1
			For Local y0:Int=y To y+dy-1
				If(GameManager.tilemap.data[x0, y0].collision Or GameManager.tilemap.data[x0, y0].faction<>faction Or (GameManager.tilemap.data[x0, y0].structure And (GameManager.tilemap.data[x0, y0].structure.getType()=getType() Or (Not TForest(GameManager.tilemap.data[x0, y0].structure) And Not (TFruit(GameManager.tilemap.data[x0, y0].structure))))))
					Return False;
				EndIf
			Next
		Next
		Return True;
	End Method
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
		WriteInt(out, faction);
		WriteInt(out, tile.coords.x);
		WriteInt(out, tile.coords.y);
		WriteInt(out, dx);
		WriteInt(out, dy);
		WriteInt(out, price);
		WriteInt(out, Len(name));
		WriteString(out, name);
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
		faction=ReadInt(in);
		Local x:Int=ReadInt(in);
		Local y:Int=ReadInt(in);
		tile=GameManager.tilemap.data[x, y];
		If(tile)
			coords=tile.coords;
		Else
			coords=New Point.init()
		EndIf
		dx=ReadInt(in);
		dy=ReadInt(in);
		price=ReadInt(in);
		Local n:Int=ReadInt(in);
		name=ReadString(in, n);
	End Method
End Type

Type THouse Extends TStructure
	Field goods:Int[];
	Field reserved:Int[];
	Field amount:Int;
	Field areaRange:Int;
	Field direction:Int;
	Field productivity:Double;
	Field workers:TWorker[];

	Method init_THouse:THouse(tile:TTile, price:Int, dx:Int, dy:Int, name:String, frame:Int, imgId:Int=TResManager.IMG_OBJ1, direction:Int=1)
		init_TStructure(tile, price, dx, dy, name)
		init(TTileMap.getPos(coords.x, coords.y).add(New Point.init(0, 8)), imgId, frame);
		goods=New Int[TGoods.N_GOODS];
		reserved=New Int[TGoods.N_GOODS];
		Self.direction=direction;
		Return Self;
	End Method
	Method getType:Int()
		Return STRUCT_HOUSE;
	End Method
	Method place:Int(tilemap:TTilemap, x:Int, y:Int)
		If(x < 0 Or y < 0 Or x >= tilemap.dimension.x-dx Or y >= tilemap.dimension.y-dy)
			Return False;
		EndIf
		For Local x0:Int=x To x+dx-1
			For Local y0:Int=y To y+dy-1
				If(Not tilemap.data[x0, y0].structure And Not tilemap.data[x0, y0].collision)
					tilemap.data[x0, y0].placeStructure(Self)
				EndIf
			Next
		Next
		GameManager.addObject(Self);
		Return True;
	End Method
	Method erase()
		active=False;
		For Local worker:TWorker=EachIn workers
			worker.house=Null;
		Next
	End Method
	Method drawProduction(x0:Int, y0:Int, pre:Int[], out:Int[])
		SetColor(255, 255, 255);
		SetScale(0.5, 0.5);
		For Local i:Int=0 To Len(pre)-1
			DrawImage(TResManager.img[TResManager.IMG_FRUITS], x0+i*18, y0, pre[i]);
		Next
		Local off_x:Int=Len(pre)*18;
		SetColor(0, 0, 0);
		SetScale(1, 1);
		DrawText(">", x0+off_x+2, y0);
		SetColor(255, 255, 255);
		SetScale(0.5, 0.5);
		For Local i:Int=0 To Len(out)-1
			DrawImage(TResManager.img[TResManager.IMG_FRUITS], x0+off_x+12+i*18, y0, out[i]);
		Next
		SetScale(1, 1)
	End Method
	Method takeFromWareHouse(worker:TWorker, ingredientsId:Int)
		'take wares from warehouse
		Local path:TList;
		If(Not worker.job And GameManager.players[faction].storage[ingredientsId]>0)
			Local minRange:Int=areaRange;
			Local minWarehouse:TWareHouse=Null;
			For Local warehouse:TWareHouse=EachIn GameManager.players[faction].buildings
				If(TTileMap.inRangeSup(warehouse.coords, coords, minRange))
					path=TTileMap.AStar(Self, warehouse.tile);
					If(path)
						minRange=Max(Abs(warehouse.coords.x-coords.x), Abs(warehouse.coords.y-coords.y));
						minWarehouse=warehouse;
					EndIf
				EndIf
			Next
			If(minWarehouse)
				path=TTileMap.AStar(Self, minWarehouse.tile);
				Local path_back:TList=path.copy();
				path_back.reverse();
				worker.addAction(New TAction_Spawn.init(worker, pos));
				worker.addAction(New TAction_WalkPath.init(worker, path));
				worker.addAction(New TAction_Rest.init(worker, 0.5));
				worker.addAction(New TAction_Take.init(worker, ingredientsId, GameManager.players[faction].storage, minWarehouse));
				worker.addAction(New TAction_WalkPath.init(worker, path_back));
				worker.addAction(New TAction_Put.init(worker, goods, Self));
				worker.addAction(New TAction_Rest.init(worker, 5));
			EndIf
		EndIf
	End Method
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
		writeIntArray(out, goods);
		writeIntArray(out, reserved);
		WriteInt(out, amount);
		WriteInt(out, areaRange);
		WriteInt(out, direction);
		WriteDouble(out, productivity);
		WriteInt(out, Len(workers))
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
		goods=readIntArray(in);
		reserved=readIntArray(in);
		amount=ReadInt(in);
		areaRange=ReadInt(in);
		direction=ReadInt(in);
		productivity=ReadDouble(in);
		Local n:Int=ReadInt(in);
		workers=New TWorker[n];
	End Method
End Type

Type TStreet Extends TStructure
	Field streetId:Int
	Method init_TStreet:TStreet(tile:TTile, price:Int, name:String)
		init_TStructure(tile, price, 1, 1, name)
		init(TTileMap.getPos(coords.x, coords.y), TResManager.IMG_TERRAIN, 3);
		Return Self;
	End Method
	Function updateId(tilemap:TTileMap, x:Int, y:Int)
		If(x < 0 Or y < 0 Or x >= tilemap.dimension.x Or y >= tilemap.dimension.y)
			Return;
		EndIf
		If(Not tilemap.data[x, y].structure Or Not (tilemap.data[x, y].structure.getType()=STRUCT_STREET))
			Return;
		EndIf
		Local value:Int=0;
		If(y=0 Or (y > 0  And tilemap.data[x, y-1].structure And tilemap.data[x, y-1].structure.getType()=STRUCT_STREET))
			value:+1;
		EndIf
		If(x=tilemap.dimension.x-1 Or (x < tilemap.dimension.x-1 And tilemap.data[x+1, y].structure And tilemap.data[x+1, y].structure.getType()=STRUCT_STREET))
			value:+2;
		EndIf
		If(y=tilemap.dimension.y-1 Or (y < tilemap.dimension.y-1 And tilemap.data[x, y+1].structure And tilemap.data[x, y+1].structure.getType()=STRUCT_STREET))
			value:+4;
		EndIf
		If(x=0 Or (x > 0 And tilemap.data[x-1, y].structure And tilemap.data[x-1, y].structure.getType()=STRUCT_STREET))
			value:+8;
		EndIf
		TStreet(tilemap.data[x, y].structure).streetId=value;
	End Function 
	Function updateId3x3(tilemap:TTileMap, x:Int, y:Int)
		updateId(tilemap, x, y);
		updateId(tilemap, x+1, y);
		updateId(tilemap, x-1, y);
		updateId(tilemap, x, y+1);
		updateId(tilemap, x, y-1);
	End Function 
	Method getType:Int()
		Return STRUCT_STREET
	End Method
	Method draw(scroll:Point)
		DrawImage(TResManager.img[imgId], Floor(pos.x+scroll.x), Floor(pos.y+scroll.y), frame+streetId);
	End Method
	
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
		WriteInt(out, streetId);
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
		streetId=ReadInt(in);
	End Method
End Type

Type TForest Extends TStructure
	Field trees:TTree[];
	Method init_TForest:TForest(tile:TTile, frames:Int[], nTrees:Int)
		init_TStructure(tile, 5, 1, 1, "Forest");
		Super.init(TTileMap.getPos(coords.x, coords.y).add(New Point.init(0, 8)), TResManager.IMG_OBJ1, 0);
		trees= New TTree[nTrees];
		Local r:Int = 0;
		For Local i:Int=0 To nTrees-1
			Local phi:Double=Rand(1, 10)*36;
			trees[i]=New TTree.init_TTree(tile, Self, New Point.init(pos.x+r*Cos(phi), pos.y+r/2.0*Sin(phi)), TResManager.IMG_OBJ1, frames[Rand(0, Len(frames)-1)], 0.8+0.1*Rand(0, 4));
			r=Min(r+5, 10);
		Next
		Return Self;
	End Method
	Method getType:Int()
		Return STRUCT_FOREST;
	End Method
	'Method draw(scroll:Point)
	'	For Local tree:TTree=EachIn trees
	'		DrawImage(TResManager.img[tree.imgId], Floor(tree.pos.x+scroll.x), Floor(tree.pos.y+scroll.y), tree.frame);
	'	Next
	'End Method
	Method erase()
		active=False;
		For Local tree:TTree=EachIn trees
			tree.active=False;
		Next
		trees=Null;
	End Method
	Method draw(scroll:Point)
	End Method
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
		WriteInt(out, Len(trees));
		For Local i:Int=0 To Len(trees)-1
			trees[i].saveToFile(out);
		Next
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
		Local n:Int=ReadInt(in);
		trees=New TTree[n];
		For Local i:Int=0 To n-1
			Local tree:TTree=New TTree;
			tree.loadFromFile(in);
			trees[i]=New TTree.init_TTree(tile, Self, tree.pos, tree.imgId, tree.frame, tree.scale);
		Next
	End Method
End Type

Type TFruit Extends TStructure
	Const GROWING:Int=1;
	Const PRODUCING:Int=2;
	
	Field fruitId:Int
	Field	fruits:TTree[];
	Field state:Int;
	Field rate:Double;'produced fruits per minute
	Field amount:Double;
	Field timer:Double;
	Field scale:Double;
	Method init_TFruit:TFruit(tile:TTile, price:Int, name:String, frame:Int, fruitId:Int, nFruits:Int, rate:Double, state:Int=GROWING)
		init_TStructure(tile, price, 1, 1, name);
		Super.init(TTileMap.getPos(coords.x, coords.y).add(New Point.init(0, 8)), 0, frame);
		Self.state=state;
		Self.rate=rate;
		Self.fruitId=fruitId;
		fruits= New TTree[nFruits];
		Local r:Int = 0;
		Local scale0:Double=1;
		If(state=GROWING)
			scale0=0.8;
			timer=10;
		Else
			amount=Rnd(0, 1);
		EndIf
		scale=scale0;
		For Local i:Int=0 To nFruits-1
			Local phi:Double=Rand(1, 10)*36;
			fruits[i]=New TTree.init_TTree(tile, Self, New Point.init(pos.x+r*Cos(phi), pos.y+r/2.0*Sin(phi)), TResManager.IMG_OBJ1, frame, scale0);
			r=Min(r+5, 10);
		Next
		Return Self;
	End Method
	Method getType:Int()
		Return STRUCT_FRUIT;
	End Method
	Method update(dt:Double)
		If(state=PRODUCING)
			amount=Min(1, amount+dt*rate/60.0); ' *GameManager.tilemap.data[coords.x, coords.y].productivity[fruitId]
		EndIf
		If(state=GROWING)
			timer:-dt;
			If(timer<=0)
				scale:+0.1;
				timer=10;
				If(scale>=1-0.0001)
					scale=1;
					state=PRODUCING;
					amount=Rnd(0, 1);
				EndIf
				For Local fruit:TTree=EachIn fruits
					fruit.scale=scale;
				Next
			EndIf
		EndIf
	End Method
	Method draw(scroll:Point)
	End Method
	Method erase()
		active=False;
		For Local fruit:TTree=EachIn fruits
			fruit.active=False;
		Next
	End Method
	
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
		WriteInt(out, Len(fruits));
		For Local i:Int=0 To Len(fruits)-1
			fruits[i].saveToFile(out);
		Next
		WriteInt(out, fruitId);
		WriteInt(out, state);
		WriteDouble(out, rate);
		WriteDouble(out, amount);
		WriteDouble(out, timer);
		WriteDouble(out, scale);
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
		Local n:Int=ReadInt(in);
		fruits=New TTree[n];
		For Local i:Int=0 To n-1
			Local tree:TTree=New TTree;
			tree.loadFromFile(in);
			fruits[i]=New TTree.init_TTree(tile, Self, tree.pos, tree.imgId, tree.frame, tree.scale);
		Next
		fruitId=ReadInt(in);
		state=ReadInt(in);
		rate=ReadDouble(in);
		amount=ReadDouble(in);
		timer=ReadDouble(in);
		scale=ReadDouble(in);
	End Method
End Type

Type TCrop Extends TStructure
	Const GROWING:Int=1;
	Const PRODUCING:Int=2;
	
	Field fruitId:Int
	Field state:Int;
	Field rate:Double;'produced crops per minute
	Field amount:Double;
	Field timer:Double;
	
	Method init_TCrop:TCrop(tile:TTile, price:Int, name:String, frame:Int, fruitId:Int, rate:Double, state:Int=GROWING)
		init_TStructure(tile, price, 1, 1, name);
		Super.init(TTileMap.getPos(coords.x, coords.y), 0, frame);
		If(tile)
			sortCoords.init(tile.coords.x, tile.coords.y);
		EndIf
		Self.state=state;
		Self.rate=rate;
		Self.fruitId=fruitId;

		If(state=GROWING)
			timer=5;
		Else
			amount=Rnd(0, 1);
		EndIf
		Return Self;
	End Method
	Method getType:Int()
		Return STRUCT_CROP;
	End Method
	Method update(dt:Double)
		If(state=PRODUCING)
			amount=Min(1, amount+dt*rate/60.0);'*GameManager.tilemap.data[coords.x, coords.y].productivity[fruitId]
		EndIf
		If(state=GROWING)
			timer:-dt;
			If(timer<=0)
				state=PRODUCING;
				amount=Rnd(0, 1);
			EndIf
		EndIf
	End Method
	Method draw(scroll:Point)
		DrawImage(TResManager.img[TResManager.IMG_TERRAIN], Floor(pos.x+scroll.x), Floor(pos.y+scroll.y), frame);
	End Method
	Method erase()
		active=False;
	End Method
	
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
		WriteInt(out, fruitId);
		WriteInt(out, state);
		WriteDouble(out, rate);
		WriteDouble(out, amount);
		WriteDouble(out, timer);
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
		fruitId=ReadInt(in);
		state=ReadInt(in);
		rate=ReadDouble(in);
		amount=ReadDouble(in);
		timer=ReadDouble(in);
	End Method
End Type
