Type TTown Extends TControl
	Field monument:TMonument;
	Method init:TTown(gold:Int)
		init_control(gold)
		Return Self
	End Method
	
	Method update(dt:Double)
		If(Not monument And getPopulation()>=1000)' And getHappyness()>=5)' >=1000, >=5
			Local tile:TTile=GameManager.tilemap.data[GameManager.world.townCenter.x+1, GameManager.world.townCenter.y+1];
			monument=New TMonument.init_TMonument()
			monument.init_THouse(tile, 0, 1, 1, "Monument", 31)
			tile.eraseStructure();
			tile.placeStructure(monument);
			GameManager.setScroll(tile.pos);
			GameManager.player.userInterface.popup_monument.pop();
		EndIf
	End Method
	
	Method buildHouse(tile:TTile, price:Int=0, dx:Int=1, dy:Int=1, nPeople:Int=1, level:Int=0, amount:Int=2, areaRange:Int=10)
		Local new_th:THouse=New TTownHouse.init_THouse(tile, price, dx, dy, "Town House", 0);
		TTownHouse(new_th).init_TTownHouse(level, amount, areaRange, nPeople);
		tile.eraseStructure();
		tile.placeStructure(new_th);
		'GameManager.players[faction].addObject(new_th);
	End Method
	
	Method getPopulation:Int()
		Local val:Int=0;
		For Local townhouse:TTownHouse=EachIn buildings
			val:+townhouse.residents;
		Next
		Return val;
	End Method
	Method getHappyness:Double()
		Local val:Int=0;
		Local n:Int=0;
		For Local townhouse:TTownHouse=EachIn buildings
			val:+townhouse.getHappyness();
			n:+1;
		Next
		Return val/Double(n);
	End Method
End Type

Type TTownHouse Extends THouse
	Field level:Int, maxLevel:Int;
	Field rates:Double[];
	Field timers:Double[];
	Field residents:Double, maxResidents:Int;
	Field happyness:Double[];
	Field reserved:Int[];
	Field expands:Int[], nExpands:Int;
	Field buy_timer:Double;
	Method init_TTownHouse:TTownHouse(level:Int, amount:Int, areaRange:Int, nPeople:Int, nResidents:Int=5, maxLevel:Int=2, v:Double=16)
		getNewFrame(level);
		Self.amount=amount;
		Self.areaRange=areaRange;
		Self.level=level;
		Self.maxLevel=maxLevel;
		workers=New TWorker[nPeople];
		residents=nResidents;
		maxResidents=2*residents;
		nExpands=4;
		expands=New Int[nExpands];
		buy_timer=Rnd(5, 15);
		Local x0:Int=Rand(0, 3);
		expands[x0]=Rand(0, 3);
		For Local i:Int=x0 To x0+nExpands-1;
			expands[(i Mod nExpands)] = (expands[((i-1+nExpands) Mod nExpands)]+3) Mod nExpands;
		Next
		If(pos)
			For Local i:Int=0 To nPeople-1
				workers[i]=New TWorker.init_TWorker(pos.copy(), v, Rand(0, 3), 2, Self)
				GameManager.addObject(workers[i]);
			Next
		EndIf
		rates=New Double[TGoods.N_GOODS];
		happyness=New Double[TGoods.N_GOODS];
		timers=New Double[TGoods.N_GOODS];
		reserved=New Int[TGoods.N_GOODS];
		Return Self
	End Method
	Method getRates()
		Local baseRates:Double[]=[Double(0.5), Double(0.5), Double(0.5), Double(0.2), Double(0.3), Double(0.2), Double(0.2), Double(0), Double(0)];
		For Local i:Int=0 To TGoods.N_GOODS-1
			rates[i]=baseRates[i]*residents/5.0;
		Next
	End Method
	Method getHappyness:Double()
		Local val:Double=0;
		For Local i:Int=0 To TGoods.N_GOODS-1
			val:+happyness[i]
		Next
		Return val;
	End Method
	Method update(dt:Double)
		getRates();
		For Local i:Int=0 To TGoods.N_GOODS-1
			If(goods[i]>=1)
				timers[i]:-dt;
				If(timers[i]<=0)
					goods[i]:-1;
					If(rates[i]>0)
						timers[i]=60.0/rates[i]
					EndIf
					'happyness[i]=1;
				EndIf
				happyness[i]=1;'Min(1, happyness[i]+rates[i]/60.0*dt);
			Else
				happyness[i]=Max(0, happyness[i]-rates[i]/60.0*dt);
			EndIf
		Next
		buy_timer:-dt;
		If(buy_timer<=0)
			buy_timer=Rnd(5, 15);
			For Local i:Int=0 To Len(workers)-1
				If(ListIsEmpty(workers[i].actionQueue) And Not workers[i].currentAction)
					newJob(workers[i], i);
				EndIf
			Next
		EndIf
	
		If(residents=maxResidents And nExpands>0)
			Select(expands[nExpands-1])
				Case 0
					expand(coords.x, coords.y, 0, 1);
				Case 1
					expand(coords.x, coords.y, 1, 0);
				Case 2
					expand(coords.x, coords.y, 0, -1);
				Case 3
					expand(coords.x, coords.y, -1, 0);
			End Select
			nExpands:-1;
		EndIf
				
		Select(level)
			Case 0
				If(getHappyness()>=4)
					residents=Min(maxResidents, residents+dt/60.0*2);
				EndIf
				If(getHappyness()>=6)
					If(residents=maxResidents)
						level:+1
						maxResidents:*2
						getNewFrame(level);
					EndIf
				EndIf
			Case 1
				If(getHappyness()>=5)
					residents=Min(maxResidents, residents+dt/60*2);
				EndIf
				'If(getHappyness()>=6)
				'EndIf
				'If(getHappyness()>=7)
				'some reward
				'EndIf
		End Select
			
		
	End Method
	
	Method newJob(worker:TWorker, id:Int)
		If(Rand(1, 3)=1)
			Local maxVendor:TVendor=Null;
			Local path:TList
			For Local control:TControl=EachIn GameManager.players
				For Local building:THouse=EachIn control.buildings
					If(TVendor(building) And TTileMap.inRangeSup(building.coords, coords, areaRange) And getMaxVendor(building.faction)>=1)
						path=TTileMap.AStar(Self, building.tile);
						If(path)
							maxVendor=TVendor(building);
							Exit;
						EndIf
					EndIf
				Next
				If(maxVendor)
					Exit
				EndIf
			Next
			If(maxVendor And path)
				Local path_back:TList=path.copy();
				Local amount:Int=0;
				path_back.reverse();
				For Local i:Int=0 To TGoods.N_GOODS-1
					If(rates[i]>0)
						amount=Max(0, Min(Int(rates[i]*30)-goods[i], GameManager.players[maxVendor.faction].storage[i]-GameManager.players[maxVendor.faction].reserved[i]));
						GameManager.players[maxVendor.faction].reserved[i]:+amount;
						reserved[i]=amount;
					EndIf
				Next
				worker.addAction(New TAction_Spawn.init(worker, pos));
				worker.addAction(New TAction_WalkPath.init(worker, path));
				worker.addAction(New TAction_Buy.init(worker, GameManager.players[maxVendor.faction], Self));
				worker.addAction(New TAction_WalkPath.init(worker, path_back));
				worker.addAction(New TAction_Rest.init(worker, 5));
			EndIf
		Else
			Local maxVendor:TVendor=Null;
			For Local control:TControl=EachIn GameManager.players
				For Local building:THouse=EachIn control.buildings
					If(TVendor(building) And TTileMap.inRangeSup(building.coords, coords, areaRange) And getMaxVendor(building.faction)>=1)
						maxVendor=TVendor(building);
						Exit;
					EndIf
				Next
				If(maxVendor)
					Exit
				EndIf
			Next
			If(maxVendor)
				Local amount:Int=0;
				For Local i:Int=0 To TGoods.N_GOODS-1
					If(rates[i]>0)
						amount=Max(0, Min(Int(rates[i]*30)-goods[i], GameManager.players[maxVendor.faction].storage[i]-GameManager.players[maxVendor.faction].reserved[i]));
						GameManager.players[maxVendor.faction].reserved[i]:+amount;
						reserved[i]=amount;
					EndIf
				Next
				worker.addAction(New TAction_Buy.init(worker, GameManager.players[maxVendor.faction], Self, 3, True));
				worker.addAction(New TAction_Rest.init(worker, 5));
			EndIf
		EndIf
	End Method
	
	Method getMaxVendor:Int(faction:Int)
		Local val:Int=0;
		For Local i:Int=0 To TGoods.N_GOODS-1
			If(rates[i]>0)
				If(goods[i]<=1 And GameManager.players[faction].storage[i]-GameManager.players[faction].reserved[i]>=1)
					val:+1;
				EndIf
			EndIf
		Next
		Return val;
	End Method
	
	Method expand:Int(x:Int, y:Int, dx:Int, dy:Int)
		If(placementPossible(faction, x+dx, y+dy))
			TTown(GameManager.players[faction]).buildHouse(GameManager.tilemap.data[x+dx, y+dy])
			residents:-5;
			Return True;
		ElseIf(TStreet(GameManager.tilemap.data[x+dx, y+dy].structure))
			dx:+Sgn(dx);
			dy:+Sgn(dy);
			If(placementPossible(faction, x+dx, y+dy))
				TTown(GameManager.players[faction]).buildHouse(GameManager.tilemap.data[x+dx, y+dy])
				residents:-5;
				Return True;
			EndIf
		EndIf
		Return False;
	End Method
	
	Method getNewFrame:Int(level:Int)
		Select(level)
			Case 0
				Local frames:Int[]=[16, 17, 18];
				direction=2*Rand(0,1)-1;
				frame=frames[Rand(0, Len(frames)-1)];
			Case 1
				Local frames:Int[]=[19, 20, 30];
				direction=2*Rand(0,1)-1;
				frame=frames[Rand(0, Len(frames)-1)];
		End Select
	End Method
	Method draw(scroll:Point)
		SetScale(direction, 1);
		Super.draw(scroll);
		SetScale(1, 1);
	End Method
	
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
		WriteInt(out, level);
		WriteInt(out, maxLevel);
		writedoubleArray(out, rates);
		writeDoubleArray(out, timers);
		WriteDouble(out, residents);
		WriteInt(out, maxResidents);
		writeDoubleArray(out, happyness);
		writeIntArray(out, reserved);
		writeintArray(out, expands);
		WriteInt(out, nExpands);
		WriteDouble(out, buy_timer);
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
		level=ReadInt(in);
		maxLevel=ReadInt(in);
		rates=readDoubleArray(in);
		timers=readDoubleArray(in);
		residents=ReadDouble(in);
		maxResidents=ReadInt(in);
		happyness=readDoubleArray(in);
		reserved=readIntArray(in);
		expands=readIntArray(in);
		nExpands=ReadInt(in);
		buy_timer=ReadDouble(in);
	End Method
End Type

Type TMonument Extends THouse
	Method init_TMonument:TMonument()
		Return Self;
	End Method
	
	Method saveToFile(out:TStream)
		Super.saveToFile(out);
	End Method
	Method loadFromFile(in:TStream)
		Super.loadFromFile(in);
	End Method
End Type