Type TUserInterface
	Const BUILDING:Int=1;
	Field state_menue:Int;
	Field player:TPlayer
	Field buttons_buildings:TButton[];
	Field buttons_storage:TButton[];
	Field popup_monument:TPopUp;
	Field button_save:TButton
	Field buttons_speedUp:TButton[];
	Method init:TUserInterface(player:TPlayer)
		Self.player=player;
		buttons_buildings=New TButton[15];
		For Local i:Int=0 To 2
			buttons_buildings[i]=New TButton.init(New Point.init(800-36*3, 80+i*36), 32, 32, i, TResManager.IMG_BUTTONS, i);
		Next
		For Local i:Int=3 To 7
			buttons_buildings[i]=New TButton.init(New Point.init(800-36*2, 80+(i-3)*36), 32, 32, i, TResManager.IMG_BUTTONS, i);
		Next
		For Local i:Int=9 To 13
			buttons_buildings[i]=New TButton.init(New Point.init(800-36*1, 80+(i-8)*36), 32, 32, i, TResManager.IMG_BUTTONS, i-1);
		Next
		buttons_buildings[8]=New TButton.init(New Point.init(800-36, 80+(8-8)*36), 32, 32, 8, TResManager.IMG_BUTTONS, 14);
		buttons_buildings[14]=New TButton.init(New Point.init(800-36, 80+(14-8)*36), 32, 32, -1, TResManager.IMG_BUTTONS, 13);
		
		buttons_storage=New TButton[9];
		For Local i:Int=0 To 8
			buttons_storage[i]=New TButton.init(New Point.init(800-36*(3-(i Mod 3)), 600-36*3+(i/3)*36), 32, 32, i, TResManager.IMG_FRUITS, i)
		Next
		popup_monument=New TPopUp.init(["A monument was built", "to honor your services", "to the city."], TResManager.IMG_OBJ1, 31, New Point.init(240, 200), New Point.init(10+16, 10+24), New Point.init(50, 10))
		button_save=New TButton.init(New Point.init(800-36*3-20, 4), 16, 16, 0, TResManager.IMG_BUTTONS2, 0);
		buttons_speedUp=New TButton[2];
		buttons_speedUp[0]=New TButton.init(New Point.init(800-36*3-40, 4), 16, 16, 0, TResManager.IMG_BUTTONS2, 2);
		buttons_speedUp[1]=New TButton.init(New Point.init(800-36*3-40, 4), 16, 16, 0, TResManager.IMG_BUTTONS2, 3);
		
		state_menue=BUILDING;
		Return Self
	End Method
	
	Method update(dt:Double)
		popup_monument.close();
		Select(state_menue)
			Case BUILDING
				For Local b:TButton=EachIn buttons_buildings
					If(b.hit())
						If(player.state=TPlayer.NONE)
							player.state=TPlayer.BUILD;
							player.buildId=b.id;
							If(player.buildId>=0 And player.buildId<Len(TControl.buildTemplates))
								GameManager.addObject(TControl.buildTemplates[player.buildId]);
							EndIf
							player.updatePreview(dt);
						ElseIf(player.state=TPlayer.BUILD And b.id<>player.buildId)
							If(player.buildId>=0 And player.buildId<Len(TControl.buildTemplates))
								TControl.buildTemplates[player.buildId].erase();
							EndIf
							player.buildId=b.id;
							If(player.buildId>=0 And player.buildId<Len(TControl.buildTemplates))
								GameManager.addObject(TControl.buildTemplates[player.buildId]);
							EndIf
						EndIf

					EndIf
				Next
		End Select
		If(button_save.hit())
			If(player.state=TPlayer.BUILD)
				player.state=TPlayer.NONE;
				If(player.buildId>=0 And player.buildId<Len(TControl.buildTemplates))
					TControl.buildTemplates[player.buildId].erase();
				EndIf
			EndIf
			GameManager.saveGameToFile("quicksave.sav");
		EndIf
		If(GameManager.speed=1 And buttons_speedUp[1].hit())
			GameManager.speed=2;
		ElseIf(GameManager.speed=2 And buttons_speedUp[0].hit())
			GameManager.speed=1;
		EndIf
	End Method
	Method draw()
		SetBlend(ALPHABLEND)
		Select(state_menue)
			Case BUILDING
				SetColor(255, 255, 255)
				DrawImage(TResManager.img[TResManager.IMG_UI_BG2], 0, 0);
				DrawImage(TResManager.img[TResManager.IMG_UI_BG], 800-112, 0);
				'buildings
				For Local b:TButton=EachIn buttons_buildings
					If(player.state=TPlayer.BUILD And player.buildId=b.id)
						SetColor(255, 255, 255)
						DrawImage(TResManager.img[TResManager.IMG_BUTTONS], 800-36*3, 24, b.frame)
						SetColor(0, 0, 0)
						If(player.buildId>=0)
							DrawText(TControl.buildTemplates[player.buildId].name, 800-36*3, 4);
							DrawText(TControl.buildTemplates[player.buildId].price+" G", 800-36*2, 24);
							If(TWareHouse(TControl.buildTemplates[player.buildId]))
								DrawText("Capacity +"+TWareHouse(TControl.buildTemplates[player.buildId]).amount, 800-36*3, 24+36);
							EndIf
						Else
							DrawText("Raze", 800-36*3, 4);
						EndIf
						If(player.buildId>=0 And player.buildId<Len(Tcontrol.buildTemplates))
							drawProductionInfo(THouse(TControl.buildTemplates[player.buildId]), 800-36*3, 24+36);
						EndIf
					EndIf
					b.draw();
				Next
				'storage
				For Local i:Int=0 To TGOODS.N_GOODS-1
					SetColor(255, 255, 255)
					DrawImage(TResManager.img[TResManager.IMG_FRUITS], 800-36*(3-(i Mod 3)), 600-36*3+(i/3)*36, i);
					SetColor(0, 0, 0)
					DrawText(player.storage[i], 800-36*(3-(i Mod 3))+1, 600-36*3+(i/3)*36+1);
					If(buttons_storage[i].mouseOver())
						DrawText(GameManager.world.goods[i].name+": "+player.storage[i], 800-36*3, 600-36*3-20);
					EndIf
				Next
				' marked house
				If(player.markedHouse)
					Local x0:Int=800-36*3, y0:Int=80+8*36;
					'name
					SetColor(0, 0, 0);
					DrawText(player.markedHouse.name, x0, y0);
					'picture
					SetColor(255, 255, 255);
					DrawImage(TResManager.img[TResManager.IMG_TERRAIN], x0+16, y0+20+16, 0);
					DrawImage(TResManager.img[player.markedHouse.imgId], x0+16, y0+20+24, player.markedHouse.frame);
					SetColor(0, 0, 0);
					SetAlpha(0.25);
					drawRect0(x0, y0+20, 32, 32);
					SetAlpha(1);
					'infos
					If(Not TWareHouse(player.markedHouse) And Not TVendor(player.markedHouse) And Not TTownHouse(player.markedHouse) And Not TMonument(player.markedHouse))
						DrawText(Int(player.markedHouse.productivity*100)+"%", x0+36, y0+20);
					EndIf
					If(TTownHouse(player.markedHouse))
						DrawText("Residents: "+Int(Floor(TTownHouse(player.markedHouse).residents)), x0, y0+20+36);
						'happyness bar
						SetColor(0, 0, 0);
						DrawRect(x0, y0+40+36, 102, 10);
						Local percent:Double=Max(1, 100*TTownHouse(player.markedHouse).getHappyness()/7.0)
						SetColor(128-64*percent/100.0, 255-60+60*percent/100.0, 0);
						DrawRect(x0+1, y0+40+36+1, percent, 8);
						SetColor(0, 0, 0);
						If(TTownHouse(player.markedHouse).level=0)
							DrawRect(x0+1+100*4/7.0, y0+40+36-1, 1, 12);
							DrawRect(x0+1+100*6/7.0, y0+40+36-1, 1, 12);
						ElseIf(TTownHouse(player.markedHouse).level=1)
							DrawRect(x0+1+100*5/7.0, y0+40+36-1, 1, 12);
						EndIf
'						DrawText("Happyness: "+Left(Int(TTownHouse(player.markedHouse).getHappyness()*10)/10.0, 3), 800-36*3, 600-20);
					EndIf
					If(TWareHouse(player.markedHouse))
						SetColor(0, 0, 0);
						DrawText("Capacity: "+player.getMaxCapacity(), x0, y0+20+36);
					EndIf
					drawProductionInfo(player.markedHouse, x0, y0+20+36);
				EndIf
				'top bar
				SetColor(0, 0, 0)
				DrawText("Gold: "+player.gold+" G", 200, 4);
				draw_TownUI();
				button_save.draw();
				If(GameManager.speed=1)
					buttons_speedUp[1].draw();
				ElseIf(GameManager.speed=2)
					buttons_speedUp[0].draw();
				EndIf
				popup_monument.draw();
		End Select
		SetBlend(MASKBLEND)
	End Method
	
	Method draw_TownUI(townFaction:Int=1)
		If(Not TTown(GameManager.players[townFaction]))
			Return;
		EndIf
		If(player.focusTile And player.focusTile.faction=townFaction)
			SetColor(0, 0, 0)
			DrawText("Population: "+ TTown(GameManager.players[townFaction]).getPopulation(), 400, 4)
		EndIf
	End Method
	
	Method drawProductionInfo(house:THouse, x0:Int, y0:Int)
		'production info
		If(TCakeBaker(house))
			house.drawProduction(x0, y0, [TGoods.GOODS_APPLES, TGoods.GOODS_FLOUR], [TGoods.GOODS_CAKE]);
		EndIf
		If(TJuiceFactory(house))
			house.drawProduction(x0, y0, [TGoods.GOODS_BERRIES, TGoods.GOODS_CHERRIES], [TGoods.GOODS_JUICE]);
		EndIf
		If(TWindMill(house))
			house.drawProduction(x0, y0, [TGoods.GOODS_CROP], [TGoods.GOODS_FLOUR]);
		EndIf
		If(TFarm(house))
			house.drawProduction(x0, y0, Null, [TGoods.GOODS_CROP]);
		EndIf
		If(TFruitPicker(house))
			house.drawProduction(x0, y0, Null, [TGoods.GOODS_BERRIES, TGoods.GOODS_APPLES, TGoods.GOODS_CHERRIES, TGoods.GOODS_BANANAS, TGoods.GOODS_MELONS]);
		EndIf
	End Method
End Type



Type TButton
	Field down:Int;
	Field pos:Point;
	Field dim:Point;
	Field id:Int;
	Field imgId:Int, frame:Int;	

	Method init:TButton(pos:Point, dx:Int, dy:Int, id:Int, imgId:Int, frame:Int)
		down = False
		Self.pos=pos;
		Self.id = id;
		Self.imgId=imgId;
		Self.frame=frame;
		dim=New Point.init(dx, dy);
		Return Self;
	End Method
	Method mouseOver:Int()
		If(pos.x < MouseX() And MouseX() < pos.x+dim.x And pos.y < MouseY() And MouseY() < pos.y+dim.y)
			Return True;
		EndIf
		Return False;
	End Method	
	Method hit:Int()
		If(mouseOver() And MHit1)
			down=True;
		EndIf
		If(down And Not MouseDown(1))
			down=False;
			If(mouseOver())
				Return True;
			EndIf
		EndIf
		Return False;
	End Method
	
	Method draw()
		SetColor(255, 255, 255)
		If(mouseover())
			SetColor(196, 196, 196)
		EndIf
		If(down)
			SetColor(128, 128, 128)
		EndIf
		DrawImage(TResManager.img[imgId], pos.x, pos.y, frame);
	End Method
End Type

Type TButton_Text Extends TButton
	Field text:String;	

	Method init_text:TButton_Text(pos:Point, dx:Int, dy:Int, id:Int, imgId:Int, frame:Int, text:String)
		down = False
		Self.pos=pos;
		Self.id = id;
		Self.imgId=imgId;
		Self.frame=frame;
		Self.text=text
		dim=New Point.init(dx, dy);
		Return Self;
	End Method
	Method mouseOver:Int()
		If(pos.x < MouseX() And MouseX() < pos.x+dim.x And pos.y < MouseY() And MouseY() < pos.y+dim.y)
			Return True;
		EndIf
		Return False;
	End Method	
	Method hit:Int()
		If(mouseOver() And MHit1)
			down=True;
		EndIf
		If(down And Not MouseDown(1))
			down=False;
			If(mouseOver())
				Return True;
			EndIf
		EndIf
		Return False;
	End Method
	
	Method draw()
		SetColor(255, 255, 255)
		If(mouseover())
			SetColor(196, 196, 196)
		EndIf
		If(down)
			SetColor(128, 128, 128)
		EndIf
		DrawImage(TResManager.img[imgId], pos.x, pos.y, frame);
		SetColor(0, 0, 0)
		SetBlend(ALPHABLEND);
		DrawText(text, pos.x+dim.x/2-TextWidth(text)/2, pos.y+dim.y/2-TextHeight(text)/2+2);
		SetBlend(MASKBLEND);
		SetColor(255, 255, 255)
	End Method
End Type

Type TPopUp
	Field active:Int;
	Field closeIt:Int
	Field text:String[];
	Field imgId:Int, frame:Int;
	Field pos:Point;
	Field imgPos:Point;
	Field textPos:Point;
	Method init:TPopUp(text:String[], imgId:Int, fr:Int, pos:Point, imgPos:Point, textPos:Point)
		active=False;
		closeIt=False;
		Self.text=text;
		Self.imgId=imgId;
		frame=fr;
		Self.pos=pos;
		Self.imgPos=imgPos;
		Self.textPos=textPos;
		Return Self;
	End Method
	
	Method pop()
		active=True;
		closeIt=False;
	End Method
	Method close()
		If(active And MHit1)
			closeIt=True;
		EndIf
		If(active And closeIt And Not MouseDown(1))
			active=False;
		EndIf
	End Method
	Method draw()
		If(active)
			SetColor(255, 255, 255);
			DrawImage(TResManager.img[TResManager.IMG_UI_BG3], pos.x, pos.y);
			DrawImage(TResManager.img[imgId], pos.x+imgPos.x, pos.y+imgPos.y, frame);
			For Local i:Int=0 To Len(text)-1
				SetColor(0, 0, 0);
				DrawText(text[i], pos.x+textPos.x, pos.y+textPos.y+i*(TextHeight("I")+2))
			Next
		EndIf
	End Method
End Type

Function drawRect0(x:Int, y:Int, dx:Int, dy:Int)
	DrawRect(x, y,        dx, 1);
	DrawRect(x, y+1,      1, dy-1);
	DrawRect(x+1, y+dy-1, dx-1, 1);
	DrawRect(x+dx-1, y+1, 1, dy-2);
End Function
