Type TWorld
	Field tilemap:TTileMap;
	Field townCenter:Point;
	Field townRange:Int;
	Field goods:TGoods[];
	Method init:TWorld(tm:TTileMap, center:Point, range:Int)
		tilemap=tm;
		townCenter=center;
		townRange=range;
		goods=TGoods.loadGoods();
		Return Self;
	End Method
	Method createWorld()
		For Local x0:Int=0 To tilemap.dimension.x-1 Step 5
			For Local y0:Int=0 To tilemap.dimension.y-1 Step 5
				If(TTileMap.inRange(TTileMap.getPos(townCenter.x, townCenter.y), TTileMap.getPos(x0, y0), townRange))
					For Local x1:Int=x0 To x0+4
						For Local y1:Int=y0 To y0+4
							tilemap.data[x1, y1].faction=1;
							If((x1+3) Mod 5=0 Or (y1+3) Mod 5=0)
								tilemap.data[x1, y1].placeStructure(New TStreet.init_TStreet(tilemap.data[x1, y1], 5, "Street"));
								TStreet.updateId3x3(tilemap, x1, y1)
							Else
								If(((x1+3) Mod 5=1 Or (x1+3) Mod 5=4 Or (y1+3) Mod 5=1 Or (y1+3) Mod 5=4) And Rand(1, 10)=1)
									TTown(GameManager.players[1]).buildHouse(tilemap.data[x1, y1]);
								ElseIf(Rand(1, 10)=1)
									tilemap.data[x1, y1].placeStructure(New TForest.init_TForest(tilemap.data[x1, y1], [8, 9], Rand(1, 2)));
								EndIf
							EndIf
						Next
					Next
				Else
					Local id:Int=Rand(1, 30)
					Local fr:Int;
					Local name:String;
					Select(id)
						Case 1
							id=TGoods.GOODS_APPLES;
							fr=6;
							name="Apple Tree"
						Case 2
							id=TGoods.GOODS_CHERRIES;
							fr=5;
							name="Cherry Tree"
						Case 3
							id=TGoods.GOODS_BERRIES;
							fr=11;
							name="Berry Bush"
						Default
							If(id>15 And id<30)
								id=-1;
							Else
								If(id=30)
									
								Else
									id=-2;
								EndIf
							EndIf
							
					End Select
					If(id=30)
						placeLake(x0, y0, Rand(1, 3));
					Else
						For Local x1:Int=x0 To x0+4
							For Local y1:Int=y0 To y0+4
								If(Rand(1, 3)=1)
									If(id>=0)
										If(id=TGoods.GOODS_BERRIES)
											tilemap.data[x1, y1].placeStructure(New TFruit.init_TFruit(tilemap.data[x1, y1], 5, name, fr, id, Rand(1, 2), 0.33, TFruit.PRODUCING));
										Else
											tilemap.data[x1, y1].placeStructure(New TFruit.init_TFruit(tilemap.data[x1, y1], 5, name, fr, id, 1, 0.33, TFruit.PRODUCING));
										EndIf
									Else
										If(id=-1)
											tilemap.data[x1, y1].placeStructure(New TForest.init_TForest(tilemap.data[x1, y1], [8, 9], Rand(1, 3)));
										EndIf
									EndIf
								EndIf
							Next
						Next
					EndIf
				EndIf
			Next
		Next
		'set collision for lakes
		For Local x:Int=0 To tilemap.dimension.x-1
			For Local y:Int=0 To tilemap.dimension.y-1
				If(tilemap.data[x, y].frame<>0)
					tilemap.data[x, y].collision=True;
				EndIf
			Next
		Next
	End Method
	Method placeStartingPoint(player:TControl, StartTile:TTile)
		StartTile.faction=player.faction;
		Local wh:TWarehouse=TWarehouse(TControl.buildTemplates[1]);
		Local new_wh:THouse=New TWarehouse.init_THouse(GameManager.tilemap.data[StartTile.coords.x, StartTile.coords.y], 0, wh.dx, wh.dy, wh.name, wh.frame);
		TWarehouse(new_wh).init_TWarehouse(wh.amount, wh.areaRange, Len(wh.workers));
		TWarehouse(new_wh).initArea(player.faction);
		GameManager.tilemap.data[StartTile.coords.x, StartTile.coords.y].eraseStructure();
		GameManager.tilemap.data[StartTile.coords.x, StartTile.coords.y].placeStructure(new_wh);
	End Method
	Method placeVendor(player:TControl, vendTile:TTile)
		vendTile.faction=player.faction;
		Local vend:TVendor=TVendor(TControl.buildTemplates[2]);
		Local new_vend:THouse=New TVendor.init_THouse(vendTile, vend.price, vend.dx, vend.dy, vend.name, vend.frame);
		TVendor(new_vend).init_TVendor();
		GameManager.tilemap.data[vendTile.coords.x, vendTile.coords.y].eraseStructure();
		GameManager.tilemap.data[vendTile.coords.x, vendTile.coords.y].placeStructure(new_vend);
	End Method
	
	Method placeLake(x0:Int, y0:Int, size:Int=3)
		Local n:Int=size;
		Local seed:Point=New Point.init(Rand(1, 3), Rand(1, 3))
		GameManager.tilemap.data[x0+seed.x, y0+seed.y].collision=True;
		GameManager.tilemap.data[x0+seed.x, y0+seed.y].frame=31;
		If(Rand(1, 3)=1)
			GameManager.tilemap.data[x0+seed.x, y0+seed.y].frame=Rand(33, 34);
		EndIf
		Local x1:Int, y1:Int, n_end:Int=0;
		While(n>0 And n_end<1000)
			n_end:+1;
			x1=Rand(1, 3);
			y1=Rand(1, 3);
			If(Not GameManager.tilemap.data[x0+x1, y0+y1].collision And nextToLake(x0+x1, y0+y1))
				GameManager.tilemap.data[x0+x1, y0+y1].collision=True;
				GameManager.tilemap.data[x0+x1, y0+y1].frame=31;
				If(Rand(1, 3)=1)
					GameManager.tilemap.data[x0+x1, y0+y1].frame=Rand(33, 34);
				EndIf
				n:-1;
			EndIf
		Wend
		For Local x:Int=x0 To x0+4
			For Local y:Int=y0 To y0+4
				If(Not tilemap.data[x, y].collision)
					updateLakeFrame(x, y);
				EndIf
			Next
		Next
	End Method
	Method nextToLake:Int(x0:Int, y0:Int)
		If(TTileMap.onTileMap(GameManager.tilemap.dimension, x0+1, y0))
			If(GameManager.tilemap.data[x0+1, y0].collision)
				Return True;
			EndIf
		EndIf
		If(TTileMap.onTileMap(GameManager.tilemap.dimension, x0-1, y0))
			If(GameManager.tilemap.data[x0-1, y0].collision)
				Return True;
			EndIf
		EndIf
		If(TTileMap.onTileMap(GameManager.tilemap.dimension, x0, y0+1))
			If(GameManager.tilemap.data[x0, y0+1].collision)
				Return True;
			EndIf
		EndIf
		If(TTileMap.onTileMap(GameManager.tilemap.dimension, x0, y0-1))
			If(GameManager.tilemap.data[x0, y0-1].collision)
				Return True;
			EndIf
		EndIf
		Return False;
	End Method
	
	Method updateLakeFrame(x:Int, y:Int)
		If(Not TTileMap.onTileMap(GameManager.tilemap.dimension, x, y))
			Return;
		EndIf
		Local value:Int=0;
		If(y > 0  And tilemap.data[x, y-1].collision)
			value:+1;
		EndIf
		If(x < tilemap.dimension.x-1 And tilemap.data[x+1, y].collision)
			value:+2;
		EndIf
		If(y < tilemap.dimension.y-1 And tilemap.data[x, y+1].collision)
			value:+4;
		EndIf
		If(x > 0 And tilemap.data[x-1, y].collision)
			value:+8;
		EndIf
		Local lakeFrames:Int[]=[0, 1, 2, 3, 4, 0, 6, 0, 5, 13, 0, 0, 8, 0, 0, 12];
		If(value>0)
			tilemap.data[x, y].frame=19+lakeFrames[value];
		Else
			If(TTileMap.onTileMap(tilemap.dimension, x+1, y+1) And tilemap.data[x+1, y+1].collision)
				tilemap.data[x, y].frame=19+11;
			ElseIf(TTileMap.onTileMap(tilemap.dimension, x+1, y-1) And tilemap.data[x+1, y-1].collision)
				tilemap.data[x, y].frame=19+9;
			ElseIf(TTileMap.onTileMap(tilemap.dimension, x-1, y+1) And tilemap.data[x-1, y+1].collision)
				tilemap.data[x, y].frame=19+10;
			ElseIf(TTileMap.onTileMap(tilemap.dimension, x-1, y-1) And tilemap.data[x-1, y-1].collision)
				tilemap.data[x, y].frame=19+7;
			EndIf
		EndIf
	End Method
End Type
