SuperStrict

Include "TGameManager.bmx"
Include "TResManager.bmx"
Include "TGameObject.bmx"
Include "TTileMap.bmx"
Include "TWorld.bmx"
Include "TGoods.bmx"
Include "TPlayer.bmx"
Include "TWorker.bmx"
Include "TTown.bmx"
Include "Buildings.bmx"
Include "TUserInterface.bmx"

Include "Point.bmx"

Global MHit1:Int = False, MHit2:Int = False, KeyHitEsc:Int=False;
AppTitle="BCC #61 - Fruits"
Graphics 800, 600
DrawText("loading..", 10, 10);Flip
SeedRnd(MilliSecs())
Local gtimer:ttimer = CreateTimer(60)
Local dt:Double

TResManager.loadGraphics();
Global GameManager:TGameManager=New TGameManager.init();
SetClsColor(32, 32, 32)
'OnEnd(autosave);
'------------------------------------
While(Not AppTerminate())
	WaitTimer(gtimer)
	MHit1 = MouseHit(1); MHit2 = MouseHit(2)
	KeyHitEsc=KeyHit(KEY_ESCAPE);
	Cls
	dt = Min(getElapsedTime(), 0.5)
	GameManager.update(GameManager.speed*dt);
	GameManager.draw();
	fps(4, 4)
	Flip(0)
Wend
End

Function autosave()
	If(GameManager.state=TGameManager.STATE_GAME)
		If(GameManager.player.state=TPlayer.BUILD)
			GameManager.player.state=TPlayer.NONE;
			If(GameManager.player.buildId>=0 And GameManager.player.buildId<Len(TControl.buildTemplates))
				TControl.buildTemplates[GameManager.player.buildId].erase();
			EndIf
		EndIf
		GameManager.saveGameToFile("autosave.sav")
	EndIf
End Function
'------------------------------------
Function fps(x:Int, y:Int, refreshtimer:Int=500)
	Global fps:Int=0
	Global fps_count:Int=0
	Global fps_timer:Int=MilliSecs()
	fps_count:+1
	If(MilliSecs()-fps_timer>=refreshtimer)
		fps=fps_count*1000.0/refreshtimer
		fps_count=0
		fps_timer=MilliSecs()
	EndIf
	SetColor(0, 0, 0)
	SetBlend(ALPHABLEND)
	DrawText("FPS: "+fps, x, y)
	SetColor(255, 255, 255)
	SetBlend(MASKBLEND)
End Function
Function getElapsedTime:Double()
	Global timer:Int = MilliSecs()
	Local tmp:Double = (MilliSecs()-timer)/1000.0
	timer = MilliSecs()
	Return tmp
End Function

Function det:Double(x1:Double, y1:Double, x2:Double, y2:Double)
	Return x1*y2-x2*y1
End Function

Function norm2_double:Double(x1:Double, y1:Double, x2:Double=0, y2:Double=0)
	Return Sqr((x1-x2)^2+(y1-y2)^2)
End Function

Function writeIntArray(stream:TStream, array:Int[])
	WriteInt(stream, Len(array))
	For Local i:Int=0 To Len(array)-1
		WriteInt(stream, array[i]);
	Next
End Function
Function ReadIntArray:Int[](stream:TStream)
	Local n:Int=ReadInt(stream);
	Local array:Int[]=New Int[n];
	For Local i:Int=0 To n-1
		array[i]=ReadInt(stream);
	Next
	Return array;
End Function
Function writeDoubleArray(stream:TStream, array:Double[])
	WriteInt(stream, Len(array))
	For Local i:Int=0 To Len(array)-1
		WriteDouble(stream, array[i]);
	Next
End Function
Function readDoubleArray:Double[](stream:TStream)
	Local n:Int=ReadInt(stream);
	Local array:Double[]=New Double[n];
	For Local i:Int=0 To n-1
		array[i]=ReadDouble(stream);
	Next
	Return array;
End Function